=== bindings/CMakeLists.txt ===
if(python)
  if(NOT pyroot_experimental)
    add_subdirectory(pyroot)
  else()
    add_subdirectory(pyroot_experimental)
  endif()
endif()
if(ruby)
  add_subdirectory(ruby)
endif()
if(r)
  add_subdirectory(r)
endif()
