=== gui/CMakeLists.txt ===
add_subdirectory(gui)
add_subdirectory(ged)
add_subdirectory(fitpanel)
add_subdirectory(guibuilder)
add_subdirectory(guihtml)
add_subdirectory(recorder)
add_subdirectory(sessionviewer)

if(cxx14 OR cxx17 OR root7)
   add_subdirectory(webdisplay)
   if(cefweb)
      add_subdirectory(cefdisplay)
   endif()
   if(qt5web)
      add_subdirectory(qt5webdisplay)
   endif()
   add_subdirectory(webgui6)
endif()

if(root7)
  add_subdirectory(canvaspainter)
  add_subdirectory(fitpanelv7)
endif()
if(qtgsi)
  add_subdirectory(qtgsi)
endif()
if(qt)
  add_subdirectory(qtroot)
endif()
