=== build/package/debian/control ===
Source: root-system
Section: science
Priority: optional
Maintainer: Antonio Salvucci <s4lb04@gmail.com>
Homepage: http://root.cern.ch
Build-Depends: debhelper (>= 5.0.37.2), po-debconf, libssl-dev, comerr-dev, libxpm-dev, x11proto-xext-dev, libxext-dev, libfreetype6-dev, libpcre3-dev, zlib1g-dev | libz-dev, python-dev (>= 2.1), graphviz, ttf-freefont, libncurses5-dev | libcurses-dev, libgraphviz-dev, libxft-dev, python-support (>= 0.3), ruby (>= 1.8), ruby1.8-dev | ruby-dev (>= 1.8), libglu1-mesa-dev | libglu1-xorg-dev | xlibmesa-glu-dev |  libglu-dev, libglew1.5-dev | libglew-dev, libftgl-dev | ftgl-dev, libxml2-dev, libgsl0-dev, libldap2-dev | libldap-dev, libavahi-compat-libdnssd-dev, libxmlrpc-c3-dev | libxmlrpc-c-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev | libcurl-dev, libjpeg62-dev, libpng12-dev, libtiff4-dev, libgif-dev | libungif4-dev, libxinerama-dev, libfftw3-dev | fftw3-dev, libglobus-gss-assist-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-credential-dev, libglobus-common-dev, libglobus-gsi-callback-dev, libglobus-gsi-sysconfig-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-callback-dev, libglobus-gsi-cert-utils-dev, libglobus-openssl-dev, libglobus-gsi-proxy-core-dev, libglobus-callout-dev, globus-proxy-utils,krb5-user|heimdal-clients, libmysqlclient15-dev | libmysqlclient14-dev| libmysqlclient12-dev| libmysqlclient-dev, libiodbc2-dev | unixodbc-dev,  libpq-dev | postgresql-dev, gfortran|fortran-compiler, libqt4-dev (>= 4.3.0) | libqt3-mt-dev (>= 3.3.0), qt4-dev-tools (>= 4.3.0) | qt3-dev-tools (>= 3.3.0), libqt4-opengl-dev, libkrb5-dev|heimdal-dev
Standards-Version: 3.8.3

Package: root-system
Architecture: all
Depends: root-system-bin, libroot-core-dev, ${misc:Depends}
Recommends: libroot-graf3d-gl-dev (>= ${binary:Version}), libroot-io-xmlparser-dev (>= ${binary:Version}), libroot-math-mathmore-dev (>= ${binary:Version}), libroot-math-unuran-dev (>= ${binary:Version}), libroot-misc-table-dev (>= ${binary:Version}), libroot-net-ldap-dev (>= ${binary:Version}), libroot-net-bonjour-dev (>= ${binary:Version}), root-plugin-graf2d-asimage (>= ${binary:Version}), root-plugin-gui-qt (>= ${binary:Version}), root-plugin-graf2d-qt (>= ${binary:Version}), root-plugin-math-fftw3 (>= ${binary:Version}), root-plugin-math-minuit2 (>= ${binary:Version}), root-plugin-net-krb5 (>= ${binary:Version}), root-plugin-sql-odbc (>= ${binary:Version}), root-system-xrootd (>= ${binary:Version}), root-plugin-net-netx (>= ${binary:Version}), root-plugin-net-xrootd (>= ${binary:Version}), libroot-geom-dev (>= ${binary:Version}), libroot-graf2d-gpad-dev (>= ${binary:Version}), libroot-graf2d-graf-dev (>= ${binary:Version}), libroot-graf2d-postscript-dev (>= ${binary:Version}), libroot-graf3d-eve-dev (>= ${binary:Version}), libroot-graf3d-g3d-dev (>= ${binary:Version}), libroot-gui-dev (>= ${binary:Version}), libroot-gui-ged-dev (>= ${binary:Version}), libroot-hist-dev (>= ${binary:Version}), libroot-hist-spectrum-dev (>= ${binary:Version}), libroot-io-dev (>= ${binary:Version}), libroot-math-foam-dev (>= ${binary:Version}), libroot-math-genvector-dev (>= ${binary:Version}), libroot-math-mathcore-dev (>= ${binary:Version}), libroot-math-matrix-dev (>= ${binary:Version}), libroot-math-minuit-dev (>= ${binary:Version}), libroot-math-mlp-dev (>= ${binary:Version}), libroot-math-physics-dev (>= ${binary:Version}), libroot-math-quadp-dev (>= ${binary:Version}), libroot-math-smatrix-dev (>= ${binary:Version}), libroot-math-splot-dev (>= ${binary:Version}), libroot-misc-minicern-dev (>= ${binary:Version}), libroot-misc-memstat-dev (>= ${binary:Version}), libroot-montecarlo-eg-dev (>= ${binary:Version}), libroot-montecarlo-vmc-dev (>= ${binary:Version}), libroot-net-dev (>= ${binary:Version}), libroot-net-auth-dev (>= ${binary:Version}), libroot-proof-dev (>= ${binary:Version}), libroot-proof-proofplayer-dev (>= ${binary:Version}), libroot-tmva-dev (>= ${binary:Version}), libroot-tree-dev (>= ${binary:Version}), libroot-tree-treeplayer-dev (>= ${binary:Version}), root-plugin-geom-geombuilder (>= ${binary:Version}), root-plugin-geom-geompainter (>= ${binary:Version}), root-plugin-graf2d-x11 (>= ${binary:Version}), root-plugin-graf3d-x3d (>= ${binary:Version}), root-plugin-gui-fitpanel (>= ${binary:Version}), root-plugin-gui-guibuilder (>= ${binary:Version}), root-plugin-gui-sessionviewer (>= ${binary:Version}), root-plugin-hist-hbook (>= ${binary:Version}), root-plugin-hist-histpainter (>= ${binary:Version}), root-plugin-hist-spectrumpainter (>= ${binary:Version}), root-plugin-io-sql (>= ${binary:Version}), root-plugin-io-xml (>= ${binary:Version}), root-plugin-math-fumili (>= ${binary:Version}), root-plugin-proof-xproof (>= ${binary:Version}), root-plugin-tree-treeviewer (>= ${binary:Version}), root-system-doc  (>= ${binary:Version})
Suggests: libroot-bindings-python-dev (>= ${binary:Version}), libroot-bindings-ruby-dev (>= ${binary:Version}), libroot-proof-clarens-dev (>= ${binary:Version}), libroot-roofit-dev (>= ${binary:Version}), root-plugin-geom-gdml (>= ${binary:Version}), root-plugin-net-globus (>= ${binary:Version}), root-plugin-proof-peac (>= ${binary:Version}), root-plugin-sql-mysql (>= ${binary:Version}), root-plugin-sql-pgsql (>= ${binary:Version})
Description: metapackage to install all ROOT packages
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently.
 .
 With the data defined as a set of objects, specialized storage methods
 can give direct access to the separate attributes of the selected
 objects, without having to touch the bulk of the data. Included are
 histogramming methods in 1, 2 and 3 dimensions, curve fitting, function
 evaluation, minimization, graphics and visualization classes to allow the
 easy creation of an analysis system that can query and process the data
 interactively or in batch mode.
 .
 The command language, the scripting (or macro) language, and the   
 programming language are all C++, thanks to the built-in CINT C++    
 interpreter. This interpreter removes the time consuming compile/link
 cycle, allowing for fast prototyping of the macros, and providing a
 good environment to learn C++. If more performance is needed, the
 interactively developed macros can be compiled using a C++ compiler.
 .
 The system has been designed in such a way that it can query its
 databases in parallel on MPP machines or on clusters of workstations
 or high-end PCs. ROOT is an open system that can be dynamically
 extended by linking external libraries. This makes ROOT a premier
 platform on which to build data acquisition, simulation and data
 analysis systems.
 .
 This package is a metapackage to ensure the installation of all
 possible ROOT packages on a system. 
 

Package: libroot-bindings-python5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends} 
Replaces: root-plugin-python  (<< 5.09.01-1)
Description: Python extension for ROOT - runtime libraries 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-python-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-python5.24 (= ${binary:Version}), libroot-core-dev, python-dev (>= 2.1), ${python:Depends}, ${misc:Depends} 
Provides: ${python:Provides}
Replaces: libroot-python-dev
Conflicts: libroot-python-dev (<< 5.19.01-1)
Description: Python extension for ROOT - development files 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-ruby5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends} 
Replaces: root-plugin-ruby  (<< 5.09.01-1)
Description: Ruby extension for ROOT - run-time library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.  The interface
 goes both ways - that is, you can call ROOT functions from Ruby, and
 invoke the Ruby interpreter from ROOT. 

Package: libroot-bindings-ruby-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-ruby5.24 (= ${binary:Version}), libroot-core-dev, ruby1.8-dev | ruby-dev (>= 1.8), ${misc:Depends} 
Conflicts: libroot-ruby (<< 5.19.01-1)
Replaces: libroot-ruby
Description: Ruby extension for ROOT - development headers
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.

Package: libroot-graf3d-gl5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl (<< 5.19.00-1)
Provides: root-plugin-graf3d-gl
Description: GL plugin for ROOT - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT, as well as 3D 
 rendering of histograms, and similar.  Included is also a high quality 
 3D viewer for ROOT defined geometries.

Package: libroot-graf3d-gl-dev
Architecture: any
Section: libdevel
Depends: libroot-graf3d-gl5.24 (= ${binary:Version}), ${misc:Depends}
Conflicts: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl
Description: GL plugin for ROOT - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT.  Included is also
 a high quality 3D viewer for ROOT defined geometries.

Package: libroot-io-xmlparser5.24
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Input/output of ROOT objects - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides I/O routines for ROOT objects. 

Package: libroot-io-xmlparser-dev
Architecture: any
Section: libdevel
Depends: libroot-io-xmlparser5.24 (= ${binary:Version}), libroot-core-dev, ${misc:Depends}
Replaces: libroot-dev, root-plugin-xml
Conflicts: libroot-dev (<< 5.19.01-1), root-plugin-xml (<< 5.19.01-1)
Description: Input/output of ROOT objects - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides I/O routines for ROOT objects. 

Package: libroot-math-mathmore5.24
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GSL interface library for ROOT
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the MathMore library for ROOT.  This provides 
 a partial GNU Scientific Library interface for ROOT.

Package: libroot-math-mathmore-dev
Architecture: any
Section: libdevel
